/***** This code was generated by Yaggo. Do not edit ******/

#ifndef __JF_ALIGNER_CMDLINE_HPP__
#define __JF_ALIGNER_CMDLINE_HPP__

#include <stdint.h>
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <string.h>
#include <stdexcept>
#include <string>
#include <limits>
#include <vector>
#include <iostream>
#include <sstream>
#include <memory>

class jf_aligner_cmdline {
 // Boiler plate stuff. Conversion from string to other formats
  static bool adjust_double_si_suffix(double &res, const char *suffix) {
    if(*suffix == '\0')
      return true;
    if(*(suffix + 1) != '\0')
      return false;

    switch(*suffix) {
    case 'a': res *= 1e-18; break;
    case 'f': res *= 1e-15; break;
    case 'p': res *= 1e-12; break;
    case 'n': res *= 1e-9;  break;
    case 'u': res *= 1e-6;  break;
    case 'm': res *= 1e-3;  break;
    case 'k': res *= 1e3;   break;
    case 'M': res *= 1e6;   break;
    case 'G': res *= 1e9;   break;
    case 'T': res *= 1e12;  break;
    case 'P': res *= 1e15;  break;
    case 'E': res *= 1e18;  break;
    default: return false;
    }
    return true;
  }

  static double conv_double(const char *str, ::std::string &err, bool si_suffix) {
    char *endptr = 0;
    errno = 0;
    double res = strtod(str, &endptr);
    if(errno) {
      err.assign(strerror(errno));
      return (double)0.0;
    }
    bool invalid =
      si_suffix ? !adjust_double_si_suffix(res, endptr) : *endptr != '\0';
    if(invalid) {
      err.assign("Invalid character");
      return (double)0.0;
    }
    return res;
  }

  static int conv_enum(const char* str, ::std::string& err, const char* const strs[]) {
    int res = 0;
    for(const char* const* cstr = strs; *cstr; ++cstr, ++res)
      if(!strcmp(*cstr, str))
        return res;
    err += "Invalid constant '";
    err += str;
    err += "'. Expected one of { ";
    for(const char* const* cstr = strs; *cstr; ++cstr) {
      if(cstr != strs)
        err += ", ";
      err += *cstr;
    }
    err += " }";
    return -1;
  }

  template<typename T>
  static bool adjust_int_si_suffix(T &res, const char *suffix) {
    if(*suffix == '\0')
      return true;
    if(*(suffix + 1) != '\0')
      return false;

    switch(*suffix) {
    case 'k': res *= (T)1000; break;
    case 'M': res *= (T)1000000; break;
    case 'G': res *= (T)1000000000; break;
    case 'T': res *= (T)1000000000000; break;
    case 'P': res *= (T)1000000000000000; break;
    case 'E': res *= (T)1000000000000000000; break;
    default: return false;
    }
    return true;
  }

  template<typename T>
  static T conv_int(const char *str, ::std::string &err, bool si_suffix) {
    char *endptr = 0;
    errno = 0;
    long long int res = strtoll(str, &endptr, 0);
    if(errno) {
      err.assign(strerror(errno));
      return (T)0;
    }
    bool invalid =
      si_suffix ? !adjust_int_si_suffix(res, endptr) : *endptr != '\0';
    if(invalid) {
      err.assign("Invalid character");
      return (T)0;
    }
    if(res > ::std::numeric_limits<T>::max() ||
       res < ::std::numeric_limits<T>::min()) {
      err.assign("Value out of range");
      return (T)0;
    }
    return (T)res;
  }

  template<typename T>
  static T conv_uint(const char *str, ::std::string &err, bool si_suffix) {
    char *endptr = 0;
    errno = 0;
    while(isspace(*str)) { ++str; }
    if(*str == '-') {
      err.assign("Negative value");
      return (T)0;
    }
    unsigned long long int res = strtoull(str, &endptr, 0);
    if(errno) {
      err.assign(strerror(errno));
      return (T)0;
    }
    bool invalid =
      si_suffix ? !adjust_int_si_suffix(res, endptr) : *endptr != '\0';
    if(invalid) {
      err.assign("Invalid character");
      return (T)0;
    }
    if(res > ::std::numeric_limits<T>::max()) {
      err.assign("Value out of range");
      return (T)0;
    }
    return (T)res;
  }

  template<typename T>
  static ::std::string vec_str(const std::vector<T> &vec) {
    ::std::ostringstream os;
    for(typename ::std::vector<T>::const_iterator it = vec.begin();
        it != vec.end(); ++it) {
      if(it != vec.begin())
        os << ",";
      os << *it;
    }
    return os.str();
  }

  class string : public ::std::string {
  public:
    string() : ::std::string() {}
    explicit string(const ::std::string &s) : std::string(s) {}
    explicit string(const char *s) : ::std::string(s) {}
    int as_enum(const char* const strs[]) {
      ::std::string err;
      int res = conv_enum((const char*)this->c_str(), err, strs);
      if(!err.empty())
        throw ::std::runtime_error(err);
      return res;
    }


    uint32_t as_uint32_suffix() const { return as_uint32(true); }
    uint32_t as_uint32(bool si_suffix = false) const {
      ::std::string err;
      uint32_t res = conv_uint<uint32_t>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to uint32_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    uint64_t as_uint64_suffix() const { return as_uint64(true); }
    uint64_t as_uint64(bool si_suffix = false) const {
      ::std::string err;
      uint64_t res = conv_uint<uint64_t>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to uint64_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    int32_t as_int32_suffix() const { return as_int32(true); }
    int32_t as_int32(bool si_suffix = false) const {
      ::std::string err;
      int32_t res = conv_int<int32_t>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to int32_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    int64_t as_int64_suffix() const { return as_int64(true); }
    int64_t as_int64(bool si_suffix = false) const {
      ::std::string err;
      int64_t res = conv_int<int64_t>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to int64_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    int as_int_suffix() const { return as_int(true); }
    int as_int(bool si_suffix = false) const {
      ::std::string err;
      int res = conv_int<int>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to int_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    long as_long_suffix() const { return as_long(true); }
    long as_long(bool si_suffix = false) const {
      ::std::string err;
      long res = conv_int<long>((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to long_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
    double as_double_suffix() const { return as_double(true); }
    double as_double(bool si_suffix = false) const {
      ::std::string err;
      double res = conv_double((const char*)this->c_str(), err, si_suffix);
      if(!err.empty()) {
        ::std::string msg("Invalid conversion of '");
        msg += *this;
        msg += "' to double_t: ";
        msg += err;
        throw ::std::runtime_error(msg);
      }
      return res;
    }
  };

public:
  uint64_t                       size_arg;
  bool                           size_given;
  uint32_t                       mer_arg;
  bool                           mer_given;
  uint32_t                       fine_mer_arg;
  bool                           fine_mer_given;
  uint32_t                       psa_min_arg;
  bool                           psa_min_given;
  uint32_t                       threads_arg;
  bool                           threads_given;
  int                            stretch_constant_arg;
  bool                           stretch_constant_given;
  double                         stretch_factor_arg;
  bool                           stretch_factor_given;
  double                         stretch_cap_arg;
  bool                           stretch_cap_given;
  uint32_t                       window_size_arg;
  bool                           window_size_given;
  bool                           forward_flag;
  double                         bases_matching_arg;
  bool                           bases_matching_given;
  double                         mers_matching_arg;
  bool                           mers_matching_given;
  const char *                   details_arg;
  bool                           details_given;
  const char *                   coords_arg;
  bool                           coords_given;
  bool                           max_match_flag;
  bool                           no_header_flag;
  bool                           zero_match_flag;
  uint32_t                       max_count_arg;
  bool                           max_count_given;
  const char *                   unitigs_lengths_arg;
  bool                           unitigs_lengths_given;
  const char *                   unitigs_sequences_arg;
  bool                           unitigs_sequences_given;
  bool                           compact_flag;
  uint32_t                       k_mer_arg;
  bool                           k_mer_given;
  ::std::vector<const char *>    superreads_arg;
  typedef ::std::vector<const char *>::iterator superreads_arg_it;
  typedef ::std::vector<const char *>::const_iterator superreads_arg_const_it;
  bool                           superreads_given;
  ::std::vector<const char *>    pacbio_arg;
  typedef ::std::vector<const char *>::iterator pacbio_arg_it;
  typedef ::std::vector<const char *>::const_iterator pacbio_arg_const_it;
  bool                           pacbio_given;

  enum {
    START_OPT = 1000,
    PSA_MIN_OPT,
    STRETCH_CONSTANT_OPT,
    STRETCH_FACTOR_OPT,
    STRETCH_CAP_OPT,
    WINDOW_SIZE_OPT,
    DETAILS_OPT,
    COORDS_OPT,
    MAX_MATCH_OPT,
    MAX_COUNT_OPT,
    COMPACT_OPT
  };

  jf_aligner_cmdline() :
    size_arg(0), size_given(false),
    mer_arg(0), mer_given(false),
    fine_mer_arg(0), fine_mer_given(false),
    psa_min_arg((uint32_t)13), psa_min_given(false),
    threads_arg((uint32_t)1), threads_given(false),
    stretch_constant_arg((int)10), stretch_constant_given(false),
    stretch_factor_arg((double)1.3), stretch_factor_given(false),
    stretch_cap_arg((double)10000.0), stretch_cap_given(false),
    window_size_arg((uint32_t)1), window_size_given(false),
    forward_flag(false),
    bases_matching_arg((double)17.0), bases_matching_given(false),
    mers_matching_arg((double)0.0), mers_matching_given(false),
    details_arg(""), details_given(false),
    coords_arg(""), coords_given(false),
    max_match_flag(false),
    no_header_flag(false),
    zero_match_flag(false),
    max_count_arg((uint32_t)5000), max_count_given(false),
    unitigs_lengths_arg(""), unitigs_lengths_given(false),
    unitigs_sequences_arg(""), unitigs_sequences_given(false),
    compact_flag(true),
    k_mer_arg(0), k_mer_given(false),
    superreads_arg(), superreads_given(false),
    pacbio_arg(), pacbio_given(false)
  { }

  jf_aligner_cmdline(int argc, char* argv[]) :
    size_arg(0), size_given(false),
    mer_arg(0), mer_given(false),
    fine_mer_arg(0), fine_mer_given(false),
    psa_min_arg((uint32_t)13), psa_min_given(false),
    threads_arg((uint32_t)1), threads_given(false),
    stretch_constant_arg((int)10), stretch_constant_given(false),
    stretch_factor_arg((double)1.3), stretch_factor_given(false),
    stretch_cap_arg((double)10000.0), stretch_cap_given(false),
    window_size_arg((uint32_t)1), window_size_given(false),
    forward_flag(false),
    bases_matching_arg((double)17.0), bases_matching_given(false),
    mers_matching_arg((double)0.0), mers_matching_given(false),
    details_arg(""), details_given(false),
    coords_arg(""), coords_given(false),
    max_match_flag(false),
    no_header_flag(false),
    zero_match_flag(false),
    max_count_arg((uint32_t)5000), max_count_given(false),
    unitigs_lengths_arg(""), unitigs_lengths_given(false),
    unitigs_sequences_arg(""), unitigs_sequences_given(false),
    compact_flag(true),
    k_mer_arg(0), k_mer_given(false),
    superreads_arg(), superreads_given(false),
    pacbio_arg(), pacbio_given(false)
  { parse(argc, argv); }

  void parse(int argc, char* argv[]) {
    static struct option long_options[] = {
      {"size", 1, 0, 's'},
      {"mer", 1, 0, 'm'},
      {"fine-mer", 1, 0, 'F'},
      {"psa-min", 1, 0, PSA_MIN_OPT},
      {"threads", 1, 0, 't'},
      {"stretch-constant", 1, 0, STRETCH_CONSTANT_OPT},
      {"stretch-factor", 1, 0, STRETCH_FACTOR_OPT},
      {"stretch-cap", 1, 0, STRETCH_CAP_OPT},
      {"window-size", 1, 0, WINDOW_SIZE_OPT},
      {"forward", 0, 0, 'f'},
      {"bases-matching", 1, 0, 'B'},
      {"mers-matching", 1, 0, 'M'},
      {"details", 1, 0, DETAILS_OPT},
      {"coords", 1, 0, COORDS_OPT},
      {"max-match", 0, 0, MAX_MATCH_OPT},
      {"no-header", 0, 0, 'H'},
      {"zero-match", 0, 0, '0'},
      {"max-count", 1, 0, MAX_COUNT_OPT},
      {"unitigs-lengths", 1, 0, 'l'},
      {"unitigs-sequences", 1, 0, 'u'},
      {"compact", 0, 0, COMPACT_OPT},
      {"k-mer", 1, 0, 'k'},
      {"superreads", 1, 0, 'r'},
      {"pacbio", 1, 0, 'p'},
      {"help", 0, 0, 'h'},
      {"usage", 0, 0, 'U'},
      {"version", 0, 0, 'V'},
      {0, 0, 0, 0}
    };
    static const char *short_options = "hVUs:m:F:t:fB:M:H0l:u:k:r:p:";

    ::std::string err;
#define CHECK_ERR(type,val,which) if(!err.empty()) { ::std::cerr << "Invalid " #type " '" << val << "' for [" which "]: " << err << "\n"; exit(1); }
    while(true) {
      int index = -1;
      int c = getopt_long(argc, argv, short_options, long_options, &index);
      if(c == -1) break;
      switch(c) {
      case ':':
        ::std::cerr << "Missing required argument for "
                  << (index == -1 ? ::std::string(1, (char)optopt) : std::string(long_options[index].name))
                  << ::std::endl;
        exit(1);
      case 'h':
        ::std::cout << usage() << "\n\n" << help() << std::endl;
        exit(0);
      case 'U':
        ::std::cout << usage() << "\nUse --help for more information." << std::endl;
        exit(0);
      case 'V':
        print_version();
        exit(0);
      case '?':
        ::std::cerr << "Use --usage or --help for some help\n";
        exit(1);
      case 's':
        size_given = true;
        size_arg = conv_uint<uint64_t>((const char*)optarg, err, true);
        CHECK_ERR(uint64_t, optarg, "-s, --size=uint64")
        break;
      case 'm':
        mer_given = true;
        mer_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "-m, --mer=uint32")
        break;
      case 'F':
        fine_mer_given = true;
        fine_mer_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "-F, --fine-mer=uint32")
        break;
      case PSA_MIN_OPT:
        psa_min_given = true;
        psa_min_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "    --psa-min=uint32")
        break;
      case 't':
        threads_given = true;
        threads_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "-t, --threads=uint32")
        break;
      case STRETCH_CONSTANT_OPT:
        stretch_constant_given = true;
        stretch_constant_arg = conv_int<int>((const char*)optarg, err, false);
        CHECK_ERR(int_t, optarg, "    --stretch-constant=int")
        break;
      case STRETCH_FACTOR_OPT:
        stretch_factor_given = true;
        stretch_factor_arg = conv_double((const char*)optarg, err, false);
        CHECK_ERR(double_t, optarg, "    --stretch-factor=double")
        break;
      case STRETCH_CAP_OPT:
        stretch_cap_given = true;
        stretch_cap_arg = conv_double((const char*)optarg, err, false);
        CHECK_ERR(double_t, optarg, "    --stretch-cap=double")
        break;
      case WINDOW_SIZE_OPT:
        window_size_given = true;
        window_size_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "    --window-size=uint32")
        break;
      case 'f':
        forward_flag = true;
        break;
      case 'B':
        bases_matching_given = true;
        bases_matching_arg = conv_double((const char*)optarg, err, false);
        CHECK_ERR(double_t, optarg, "-B, --bases-matching=double")
        break;
      case 'M':
        mers_matching_given = true;
        mers_matching_arg = conv_double((const char*)optarg, err, false);
        CHECK_ERR(double_t, optarg, "-M, --mers-matching=double")
        break;
      case DETAILS_OPT:
        details_given = true;
        details_arg = optarg;
        break;
      case COORDS_OPT:
        coords_given = true;
        coords_arg = optarg;
        break;
      case MAX_MATCH_OPT:
        max_match_flag = true;
        break;
      case 'H':
        no_header_flag = true;
        break;
      case '0':
        zero_match_flag = true;
        break;
      case MAX_COUNT_OPT:
        max_count_given = true;
        max_count_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "    --max-count=uint32")
        break;
      case 'l':
        forward_flag = true;
        unitigs_lengths_given = true;
        unitigs_lengths_arg = optarg;
        break;
      case 'u':
        forward_flag = true;
        unitigs_sequences_given = true;
        unitigs_sequences_arg = optarg;
        break;
      case COMPACT_OPT:
        compact_flag = false;
        break;
      case 'k':
        k_mer_given = true;
        k_mer_arg = conv_uint<uint32_t>((const char*)optarg, err, false);
        CHECK_ERR(uint32_t, optarg, "-k, --k-mer=uint32")
        break;
      case 'r':
        superreads_given = true;
        superreads_arg.push_back(optarg);
        break;
      case 'p':
        pacbio_given = true;
        pacbio_arg.push_back(optarg);
        break;
      }
    }

    // Check that required switches are present
    if(!size_given)
      error("[-s, --size=uint64] required switch");
    if(!mer_given)
      error("[-m, --mer=uint32] required switch");

    // Check mutually exlusive switches
    if(unitigs_sequences_given && unitigs_lengths_given)
      error("Switches [-u, --unitigs-sequences=path] and [-l, --unitigs-lengths=path] are mutually exclusive");

    // Parse arguments
    if(argc - optind != 0)
      error("Requires exactly 0 argument.");
  }
  static const char * usage() { return "Usage: jf_aligner_cmdline [options]"; }
  class error {
    int code_;
    std::ostringstream msg_;

    // Select the correct version (GNU or XSI) version of
    // strerror_r. strerror_ behaves like the GNU version of strerror_r,
    // regardless of which version is provided by the system.
    static const char* strerror__(char* buf, int res) {
      return res != -1 ? buf : "Invalid error";
    }
    static const char* strerror__(char* buf, char* res) {
      return res;
    }
    static const char* strerror_(int err, char* buf, size_t buflen) {
      return strerror__(buf, strerror_r(err, buf, buflen));
    }
    struct no_t { };

  public:
    static no_t no;
    error(int code = EXIT_FAILURE) : code_(code) { }
    explicit error(const char* msg, int code = EXIT_FAILURE) : code_(code)
      { msg_ << msg; }
    error(const std::string& msg, int code = EXIT_FAILURE) : code_(code)
      { msg_ << msg; }
    error& operator<<(no_t) {
      char buf[1024];
      msg_ << ": " << strerror_(errno, buf, sizeof(buf));
      return *this;
    }
    template<typename T>
    error& operator<<(const T& x) { msg_ << x; return (*this); }
    ~error() {
      ::std::cerr << "Error: " << msg_.str() << "\n"
                  << usage() << "\n"
                  << "Use --help for more information"
                  << ::std::endl;
      exit(code_);
    }
  };
  static const char * help() { return
    "Align PacBio reads and SuperReads\n\n\n\n"
    "Options (default value in (), *required):\n"
    " -s, --size=uint64                       *Number of k-mers in SuperReads\n"
    " -m, --mer=uint32                        *Mer size\n"
    " -F, --fine-mer=uint32                    Mer size for fine alignment\n"
    "     --psa-min=uint32                     Min suffix length in SA. Increase for speed up at the cost of memory (13)\n"
    " -t, --threads=uint32                     Number of threads (1)\n"
    "     --stretch-constant=int               Constant tolerated stretch between matching k-mer in LIS (10)\n"
    "     --stretch-factor=double              Factor tolerated stretch between matching k-mer in LIS (1.3)\n"
    "     --stretch-cap=double                 Maximum distance between two consecutive k-mers in LIS (10000.0)\n"
    "     --window-size=uint32                 Check stretch on every window of k-mer this size (1)\n"
    " -f, --forward                            Show all matches forward (reverse super read name if needed) (false)\n"
    " -B, --bases-matching=double              Filter base on percent of bases matching (17.0)\n"
    " -M, --mers-matching=double               Filter base on percent of k-mer matching (0.0)\n"
    "     --details=path                       Output files with detail k-mer information\n"
    "     --coords=path                        Output files with math coordinate information (stdout)\n"
    "     --max-match                          Output secondary matches (false)\n"
    " -H, --no-header                          Do not output header (false)\n"
    " -0, --zero-match                         Output header even if query has no match (false)\n"
    "     --max-count=uint32                   Maximum mer count in super read to be used for alignment (5000)\n"
    " -l, --unitigs-lengths=path               Length of k-unitigs\n"
    " -u, --unitigs-sequences=path             Fasta file containing the sequence of the k-unitigs\n"
    "     --compact                            Compact output format (true)\n"
    " -k, --k-mer=uint32                       Length of k-mer used to create k-unitigs\n"
    " -r, --superreads=path                    SuperReads sequence file\n"
    " -p, --pacbio=path                        PacBio read sequence file\n"
    " -U, --usage                              Usage\n"
    " -h, --help                               This message\n"
    " -V, --version                            Version";
  }
  static const char* hidden() { return ""; }
  void print_version(::std::ostream &os = std::cout) const {
#ifndef PACKAGE_VERSION
#define PACKAGE_VERSION "0.0.0"
#endif
    os << PACKAGE_VERSION << "\n";
  }
  void dump(::std::ostream &os = std::cout) {
    os << "size_given:" << size_given << " size_arg:" << size_arg << "\n";
    os << "mer_given:" << mer_given << " mer_arg:" << mer_arg << "\n";
    os << "fine_mer_given:" << fine_mer_given << " fine_mer_arg:" << fine_mer_arg << "\n";
    os << "psa_min_given:" << psa_min_given << " psa_min_arg:" << psa_min_arg << "\n";
    os << "threads_given:" << threads_given << " threads_arg:" << threads_arg << "\n";
    os << "stretch_constant_given:" << stretch_constant_given << " stretch_constant_arg:" << stretch_constant_arg << "\n";
    os << "stretch_factor_given:" << stretch_factor_given << " stretch_factor_arg:" << stretch_factor_arg << "\n";
    os << "stretch_cap_given:" << stretch_cap_given << " stretch_cap_arg:" << stretch_cap_arg << "\n";
    os << "window_size_given:" << window_size_given << " window_size_arg:" << window_size_arg << "\n";
    os << "forward_flag:" << forward_flag << "\n";
    os << "bases_matching_given:" << bases_matching_given << " bases_matching_arg:" << bases_matching_arg << "\n";
    os << "mers_matching_given:" << mers_matching_given << " mers_matching_arg:" << mers_matching_arg << "\n";
    os << "details_given:" << details_given << " details_arg:" << details_arg << "\n";
    os << "coords_given:" << coords_given << " coords_arg:" << coords_arg << "\n";
    os << "max_match_flag:" << max_match_flag << "\n";
    os << "no_header_flag:" << no_header_flag << "\n";
    os << "zero_match_flag:" << zero_match_flag << "\n";
    os << "max_count_given:" << max_count_given << " max_count_arg:" << max_count_arg << "\n";
    os << "unitigs_lengths_given:" << unitigs_lengths_given << " unitigs_lengths_arg:" << unitigs_lengths_arg << "\n";
    os << "unitigs_sequences_given:" << unitigs_sequences_given << " unitigs_sequences_arg:" << unitigs_sequences_arg << "\n";
    os << "compact_flag:" << compact_flag << "\n";
    os << "k_mer_given:" << k_mer_given << " k_mer_arg:" << k_mer_arg << "\n";
    os << "superreads_given:" << superreads_given << " superreads_arg:" << vec_str(superreads_arg) << "\n";
    os << "pacbio_given:" << pacbio_given << " pacbio_arg:" << vec_str(pacbio_arg) << "\n";
  }
};
#endif // __JF_ALIGNER_CMDLINE_HPP__"
